#! /bin/bash
#
# Copyright ? 2007-2019 Bonree Data Technology Co.,Ltd
# All rights reserved
#
projectPath=$(cd $(dirname $0); pwd -P)
#path_to_sdk_lib
sdkLibDir="/opt/bonree/apm/lib"
sdkCincludeDir=${projectPath}/../include/c

cleanBuild() {
	if [ -d $projectPath/build ]; then
	    rm -rf $projectPath/build/*
	else
	    mkdir $projectPath/build
  fi
  if [ -d $projectPath/target ]; then
      rm -rf $projectPath/target/*
    else
      mkdir $projectPath/target
  fi
}

build() {
    cd $projectPath/build
    cmake -DSDK_LIB_DIR=${sdkLibDir} -DSDK_C_INCLUDE_DIR=${sdkCincludeDir}  -DCMAKE_INSTALL_PREFIX=../target/ ..
    make  install
}

main(){ 
    cleanBuild
    build
}

main
