
// Created by liuheng@bonree.com on 2019/11/14 0014.
// Copyright © 2007-2019 Bonree Data Technology Co.,Ltd
// All rights reserved


#ifndef _BONREE_SDK_BTDETAIL_BE_CALL_H_
#define _BONREE_SDK_BTDETAIL_BE_CALL_H_

#include "common/common.h"
#include "common/symbols.h"
#include "common/structs.h"

#ifdef __cplusplus
extern "C" {
#endif

//struct be_call_t {
//    void *ins;
//};
typedef struct sdk_object_t be_call_t;

//结束后端调用
//参数：be_call[in]: be_call_t* 要结束的后端调用
//参数：options[in]: be_call_finish_options_t* 参数选项
//返回值： 0：成功， 非0： 失败
BONREE_SDK_API int br_finish_be_call(const  be_call_t* be_call, const  be_call_finish_options_t* options);

//设置MQ数据
//参数：be_call[in]: be_call_t* 要结束的后端调用
//参数：mq_info[in]: mq_info_t* mq 信息
//返回值： 0：成功， 非0： 失败
BONREE_SDK_API int br_set_mq_info(const  be_call_t* be_call, const  mq_info_t* mq_info);

//更新后端调用信息
//参数：options[in]: be_call_options_t, 后端调用的选项参数
//参数：be_call[in]: be_cainll_t 获取的后端调用
//返回值：0：成功， 非0：失败
BONREE_SDK_API int br_update_be_call(be_call_t* be_call, const be_call_options_t* options);

#ifdef __cplusplus
}
#endif
#endif //_BONREE_SDK_BTDETAIL_BE_CALL_H_
