'use strict';

function ConnectHook(agent)
{
    this.agent = agent;
    this.packages = ['connect'];
    this.baseHook = agent.baseHook;
}

exports.ConnectHook = ConnectHook;

ConnectHook.prototype.attach = function(obj) {
    var self = this;
    var localBaseHook = self.baseHook;

    if(obj.__bonrAttached__) return;
    obj.__bonrAttached__ = true;

    var ret = localBaseHook.bindFunction(obj);
    localBaseHook.wrapAsyncMethod(ret, 'connect.handle', null,function (obj,args,locals) {
        var txn = self.agent.tracer.getTransaction();
        var stklen = obj.stack.length;
        var Layer = obj.stack[stklen-1];
        if(Layer)
            {
                if(Layer.__bonrAttached__) return;
                Layer.__bonrAttached__ = true;
                localBaseHook.wrapAsyncMethod(Object.getPrototypeOf(Layer), 'layer.handle');
            }
    },null);

};