'use strict';

function StrongRemotineHook(agent) {
  this.agent = agent;
  this.baseHook = agent.baseHook;
  this.packages = ['strong-remoting'];
}
exports.StrongRemotineHook = StrongRemotineHook;

StrongRemotineHook.prototype.attach = function(obj, name) {
  if(obj.__bonrAttached__) return;
  obj.__bonrAttached__ = true;

  var self = this;
  var localBaseHook = self.baseHook;
  //var tracer = self.agent.tracer;

  localBaseHook.wrapSyncMethod(obj.prototype, 'RemoteObjects.handler', null, function(obj, args, ret) {
    var restAdapter = !!ret ? ret.adapter : null;
    if (!!restAdapter) {
      var methods = ['_invokeMethod','invoke'];
      methods.forEach(function(method) {
        localBaseHook.wrapAsyncMethod(restAdapter, 'RestAdapter.'+method);
      });
    }
  });


};

