'use strict';

function SuperagentHook(agent)
{
    this.agent = agent;
    this.packages = ['superagent'];
    this.baseHook = agent.baseHook;
}

exports.SuperagentHook = SuperagentHook;

var asyncMethods = [
    'get',
    'post',
    'del',
    'put'
];

SuperagentHook.prototype.attach = function(obj) {
    var self = this;
    var localBaseHook = self.baseHook;

    if(obj.__bonrAttached__) return;
    obj.__bonrAttached__ = true;

    asyncMethods.forEach(function(method) {
        localBaseHook.wrapAsyncMethod(obj, 'superagent.'+method);
    });
};