// content of index.js
//var bonree = require('/home/steven/Workspace/nodejs/node.js/trunk/bonree/index').profile({'nodeName': 'testzou', 'appName': 'testzou', 'clusterName': 'testzou', 'tierName': 'testzou', 'agentName': 'testzou1_agentname','log_path':'/tmp/agentlogs','logFileCount':8,'logLimitInKbytes':102400,'debug_transaction': true,'debug_metric': false,'debug_snapsthot': false,enablelogging: true});
//var mongodb_conf = require('./configuration/mongodb_cfg.js')
var bonree = require('bonree').profile({'configFile': './bonree.yml',enablelogging: true});
var mysql = require('mysql');
var fs = require('fs');
var ps = require('promise');
var bluebird = require("bluebird");
var when = require('when');
var Q = require('q');
var async = require('async');
//var zlib = require('zlib');

const http = require('http')
const port = 3000
var options = {
    host: '127.0.0.1',
    user: 'root',
    password: '123456',
    database: 'testdb',
    port: 3306
}

var pool = mysql.createConnection(options)  //\u5ba2\u6237\u7aef\u8fde\u63a5
var MongoClient = require('mongodb').MongoClient;
 var DB_CONN_STR = 'mongodb://192.168.1.194:27017/runoob'//mongodb_conf.mongodb
function query(sql, callback) {
    pool.query(sql, function (err, rows) {
        callback(err, rows);
    });
}

function promiseTest(response) {
    var Promise = ps;
    var file = 'contenta.txt';
    var nprom = new Promise(function(resolve, reject) {
        fs.readFile(file, function(err, data) {
            if(err) {
                reject(err);
            } else {
                resolve(data);
            }
        });
    });

    nprom.then(function(data) {
            return new Promise(function(resolve, reject) {
                fs.writeFile('ccc.txt', data, function(err) {
                    if(err) { reject(err); }
                    else {
                        console.log('write okj.');
                        resolve('write ok!');
                    }
                });
            });
        }
    ).then(function(ret) { console.log('last:', ret); }).
    catch(function(err) {console.log('err:', typeof err);}).
    finally(function() {console.log('finally!!!');});

    var p1 = new Promise(function(resolve, reject) {
        setTimeout(resolve, 1000, 'one');
    });
    var p2 = new Promise(function(resolve, reject) {
        setTimeout(resolve, 2000, 'two');
    });
    var p3 = new Promise(function(resolve, reject) {
        setTimeout(resolve, 3000, 'three');
    });
    var p4 = new Promise(function(resolve, reject) {
        setTimeout(resolve, 4000, 'four');
    });
    var p5 = new Promise(function(resolve, reject) {
        reject('reject');
    });

    Promise.all([p1, p2, p3, p4]).then(function(values) {
        console.log(values);
        response.end(values.join(','));
    }, function(reason) {
        console.log(reason)
    });

//From console:
//"reject"

//You can also use .catch
    Promise.all([p1, p2, p3, p4, p5]).then(function(values) {
        console.log(values);
    }).catch(function(reason) {
        console.log(reason);
    });
}

function bluebirdTest(response) {
    var Promise = bluebird;

//方法Promise化
    var readFileAsync = Promise.promisify(fs.readFile);

//.spread([Function fulfilledHandler] [, Function rejectedHandler ]) -> Promise
//用法:将结果集拆分
//example
    Promise.delay(0).then(function () {
        return [
            readFileAsync('1.txt', 'utf-8'),
            readFileAsync('2.txt', 'utf-8'),
            readFileAsync('3.txt', 'utf-8')
        ];
    }).spread(function (file1, file2, file3) {
        console.log(file1);
        console.log(file2);
        console.log(file3);
    })

//.finally(Function handler) -> Promise
//类似try..catch..finally中finally的作用
//example
    Promise.delay(0).then(function () {
        return [
            readFileAsync('1.txt', 'utf-8'),
            readFileAsync('2.txt', 'utf-8'),
            readFileAsync('4.txt', 'utf-8')
        ];
    }).spread(function (file1, file2, file3) {
        console.log(file1);
        console.log(file2);
        console.log(file3);
    }).catch(function (e) {
        console.log(e);
    }).finally(function () {
        //抛错最后仍执行finally中的内容；
        console.log(4)
    })

//Promise.join(Promise|Thenable|value promises..., Function handler) -> Promise
//将几个promise化的函数join起来，用法有点类似spread
//example
    var join = Promise.join;
    join(readFileAsync('1.txt', 'utf-8'),
        readFileAsync('2.txt', 'utf-8'),
        readFileAsync('3.txt', 'utf-8'), function (file1, file2, file3) {
            return parseInt(file1) + parseInt(file2) + parseInt(file3);
        }).then(function (content) {
        console.log("SUM结果:" + content);
    })

//Synchronous inspection 同步检测
//example
    var rf1 = readFileAsync('1.txt', 'utf-8');
    var rf2 = readFileAsync('2.txt', 'utf-8');
    var rf3 = readFileAsync('3.txt', 'utf-8');
    var join = Promise.join;
    join(rf1, rf2, rf3, function (file1, file2, file3) {
        return parseInt(file1) + parseInt(file2) + parseInt(file3);
    }).then(function (content) {
        console.log("SUM结果:" + content);
    }).finally(function () {
        //.isFulfilled() -> boolean
        //检测是否完成
        console.log("success:" + rf1.isFulfilled());
        //.isRejected() -> boolean
        //检测是否失败
        console.log("fail:" + rf1.isRejected());
        //.isPending() -> boolean
        //检测是否进行中
        console.log("Pending:" + rf1.isRejected());
        //.value() -> dynamic
        //成功的结果,一般使用时先判定是否完成
        if (rf1.isFulfilled()) {
            console.log(rf1.value());
        }
        //.reason() -> dynamic
        //失败原因，同样使用时先判定是否失败
        if (rf1.isRejected()) {
            console.log(rf1.reason());
        }
    })

//.all() -> Promise
//参数为数组，并且里面的已promise化，全部成功返回的也为数组
//example
    var rfAll1 = readFileAsync('1.txt', 'utf-8');
    var rfAll2 = readFileAsync('2.txt', 'utf-8');
    var rfAll3 = readFileAsync('3.txt', 'utf-8');
    var files = [rfAll1, rfAll2, rfAll3];
    Promise.all(files).then(function (s) { console.log("all:" + s) });

//.props() -> Promise
//类似于.all(),不过参数为object，全部成功返回值也为object
//example
    Promise.props({
        rfProp1: readFileAsync('1.txt', 'utf-8'),
        rfProp2: readFileAsync('2.txt', 'utf-8'),
        rfProp3: readFileAsync('3.txt', 'utf-8')
    }).then(function(content){
        console.log(JSON.stringify(content));
    })

//.settle() -> Promise
//基本等同于.all();
//example
    var rfsettle1 = readFileAsync('1.txt', 'utf-8');
    var rfsettle2 = readFileAsync('2.txt', 'utf-8');
    var rfsettle3 = readFileAsync('3.txt', 'utf-8');
    var files = [rfsettle1, rfsettle2, rfsettle3];
    Promise.all(files).then(function (s) { console.log("settle:" + s) });

//.some(int count) -> Promise
//第一个参数为数组，第二个为个数,指的返回值最先返回成功的值
//example
    var rfsome1 = readFileAsync('1.txt', 'utf-8');
    var rfsome2 = readFileAsync('2.txt', 'utf-8');
    var rfsome3 = readFileAsync('3.txt', 'utf-8');
    var files = [rfsome1, rfsome2, rfsome3];
    Promise.some(files,2).spread(function(first,second){
        console.log("some:" + first);
        console.log("some:" + second);
    })

//.map(Function mapper [, Object options]) -> Promise
//参数为数组,不需要promise化，只要map里面的函数promise化就行。 有点类似于数组的map方法
//example
    var files = ['1.txt','2.txt','3.txt'];
    Promise.map(files,function(file){
        return readFileAsync(file,'utf-8');
    }).then(function(content){
        console.log("map:" + content) ;
    })

//.reduce(Function reducer [, dynamic initialValue]) -> Promise
//概念有点像数组的reduce方法.   total为返回的组装值，fileName为item,0为初始值
//example
    Promise.reduce(["1.txt", "2.txt", "3.txt"], function(total, fileName) {
        return readFileAsync(fileName, "utf8").then(function(contents) {
            return total + parseInt(contents, 10);
        });
    }, 0).then(function(total) {
        console.log("reduce:" + total)
        response.end('bluebird ok!');
    });
}

function whenTest(response) {
    var getRssAddress = function(path) {
        var deferred = when.defer();
        fs.readFile(path, {encoding: 'utf8'}, function (err, data) {
            if (err) deferred.reject(err);
            deferred.resolve(data);
        });

        return deferred.promise;
    };
    var getRss = function(url) {
        var deferred = when.defer();
        var data = '';
        http.get(url, function(res) {
            res.on('data', function(chrunk) {
                data += chrunk;
            });
            res.on('end', function() {
                deferred.resolve(data);
            });
        }).on('error', function(err) {
            deferred.reject(err);
        });

        return deferred.promise;
    };
    var saveRss = function(data) {
        var deferred = when.defer();
        fs.writeFile('rss.txt', data, 'utf8', function(err) {
            if(err) deferred.reject(err);
            deferred.resolve();
        });

        return deferred.promise;
    };
    getRssAddress('address.txt')
        .then(getRss)
        .then(saveRss)
        .catch(function(err) {
            console.log(err);
        }).finally(function () {
        response.end('when ok!');
    });
}

function qTest(response) {
    function getPromise(msg,timeout,opt) {
        var defer = Q.defer();
        setTimeout(function(){
            console.log(msg);
            if(opt)
                defer.reject(msg);
            else
                defer.resolve(msg);
        },timeout);
        return defer.promise;
    }

    /**
     *promise1在1秒后进入fulfil状态, promise2在2秒后进入fulfil状态
     *Q.allSettled等待所有的promise完成状态转换
     *所以控制台打印 fulfiled rejected
     */
    Q.all([getPromise('promise1 resovle',1000),getPromise('promise2 reject',2000)])
    //使用spread 注意spread传入的值和Q.all里的promise一一对应
        .spread(function(pro1,pro2){
            console.log(pro1);
            console.log(pro2);
        })
        //使用then
        .then(function(result){
            result && result.forEach(function(element){
                if(Q.isPromise(element)) {
                    console.log(element.valueOf());
                }else {
                    console.log(element)
                }
            });
        }).catch(function(err) {
            console.log(err);
        }).fail(function(result){
            console.log(result);
        });

    /**
     *没有用done()结束的promise链
     *由于getPromse('2',2000,'opt')返回rejected, getPromise('3',1000)就没有执行
     *然后这个异常并没有任何提醒，是一个潜在的bug
     */
    getPromise('1',3000)
        .then(function(){return getPromise('2',2000,'opt')})
        .then(function(){return getPromise('3',1000)})
        .catch(function(err) {
            console.log(err);
        });
    /**
     *用done()结束的promise链
     *有异常抛出
     */
    getPromise('1',3000)
        .then(function(){return getPromise('2',2000,'opt')})
        .then(function(){return getPromise('3',1000)})
        .catch(function(err) {
            console.log(err);
        })
        .done(function() {
            response.end('Q ok!');
        });
}

function asyncTest(response) {
    async.parallel([
            function(callback){
                setTimeout(function(){
                    callback(null, 'one');
                }, 200);
            },
            function(callback){
                setTimeout(function(){
                    callback(null, 'two');
                }, 100);
            }
        ],
// optional callback
        function(err, results){
            // the results array will equal ['one','two'] even though
            // the second function had a shorter timeout.
            console.log('parallel result:', results);
            //response.end('async ok!');
        });
    //return;
    async.waterfall([
        function(cb) { console.log('1.1.1: ', 'start'); cb(null, 3); },
        function(n, cb) { console.log('1.1.2: ',n++); cb(null, n);},
        function(n, cb) { console.log('1.1.3: ',n++); cb(null, n);}
    ], function (err, result) {
        console.log('1.1 err: ', err);
        console.log('1.1 result: ', result);
    });

    async.auto({
        get_data: function(callback) {
            console.log('in get_data');
            // async code to get some data
            callback(null, 'data', 'converted to array');
        },
        make_folder: function(callback) {
            console.log('in make_folder');
            // async code to create a directory to store a file in
            // this is run at the same time as getting the data
            callback(null, 'folder');
        },
        write_file: ['get_data', 'make_folder', function(results, callback) {
            console.log('in write_file', JSON.stringify(results));
            // once there is some data and the directory exists,
            // write the data to a file in the directory
            callback(null, 'filename');
        }],
        email_link: ['write_file', function(results, callback) {
            console.log('in email_link', JSON.stringify(results));
            // once the file is written let's email a link to it...
            // results.write_file contains the filename returned by write_file.
            callback(null, {'file':results.write_file, 'email':'user@example.com'});
        }]
    }, function(err, results) {
        console.log('err = ', err);
        console.log('results = ', results);
        response.end('async ok!');
    });
}

const requestHandler = function(request, response) {
  if(request.url == '/tx2')
  {
   /*   query('select * from testtb where usr=\'adb\'',function(err,result){
          console.log(request.url);
          fs.watch('2.txt', function(eventType, filename) {
              console.log('事件类型是: ', eventType);
          if (filename) {
              console.log('提供的文件名:', filename);
          } else {
              console.log('未提供文件名');
          }
          });
          fs.writeFileSync('2.txt', 'new');

          // 压缩 input.txt 文件为 input.txt.gz
          /*fs.createReadStream('input.txt')
              .pipe(zlib.createGzip())
              .pipe(fs.createWriteStream('input.txt.gz'));

          console.log("文件压缩完成。");
          setTimeout(function() {
              console.log('timeout!');
              response.end('Hello tx2!' + result);
          }, 1000);
      });*/

      pool.query('select * from testtb where usr=\'adb\'').
         stream({highWaterMark: 5}).
            pipe(fs.createWriteStream('result.txt'));
      response.end('hello end!');
  } else if(request.url == '/promise') {
      promiseTest(response);
  } else if(request.url == '/bluebird') {
      bluebirdTest(response);
  } else if(request.url == '/when') {
      whenTest(response);
  } else if(request.url == '/q') {
      qTest(response);
  } else if(request.url == '/async') {
      asyncTest(response);
  }
  else
  {
 var selectData = function(db, callback) {  
  var collection = db.collection('site');
  var whereStr = {"name":'菜鸟教程'};
  collection.find(whereStr).toArray(function(err, result) {
       
    callback(err,result);
  });
}
 
   MongoClient.connect(DB_CONN_STR, function(err, db) {
     console.log("连接成功！");
     selectData(db, function(err,result) {
        db.close();
    	response.end('mongodb-query success! responsed with '+JSON.stringify(result));
     });
   });

  }
}

const server = http.createServer(requestHandler)

server.listen(port, function (err) {
  if (err) {
    return console.log('something bad happened', err)
  }

  console.log('server is listening on', port)
})
