"""
The threading module is pre-load in the interpretor environment. So
although we already hooked thread module. the threading use thread function
that before hook. For this case, we hook threading and thread both
"""
from Bonree.agent.interceptor.base import ThreadEntryPointInterceptor


class ThreadingInterceptor(ThreadEntryPointInterceptor):
    def start_data(self, md, instance, *args, **kwargs):
        btr = self.btr
        if not btr:
            return

        try:
            instance.run = self.target_wrapper(instance.run, btr)
        except AttributeError:
            pass



def intercept_threading(agent, mod):
    ThreadingInterceptor(agent, mod.Thread).attach('start')
