from Bonree.agent.interceptor.frameworks.wsgi import WSGIInterceptor


class WebobWsgifyInterceptor(WSGIInterceptor):
    def application_callable(self, application, instance, req, *args, **kwargs):
        if isinstance(req, dict):
            environ = req
            if args:
                start_response = args[0]
                return super(WebobWsgifyInterceptor, self).application_callable(application, instance, environ, start_response)
        return application(instance, req, *args, **kwargs)


def intercept_webob_response(agent, mod):
    # WSGIInterceptor(agent, mod.Response).attach('__call__')
    pass


def intercept_webob_client(agent, mod):
    # WSGIInterceptor(agent, mod.SendRequest).attach('__call__')
    pass


def intercept_webob_dec_wsgify(agent, mod):
    """webob.dec"""
    WebobWsgifyInterceptor(agent, mod.wsgify).attach('__call__')
