# Copyright (c) Bonree, Inc., and its affiliates
# 2015
# All Rights Reserved

"""Interceptor for Wsigref.

"""

from Bonree.agent.interceptor.base import OnlyStartInterceptor
from Bonree.config import setEnvironIp, setEnvironPort


class WsgirefMakeServerInterceptor(OnlyStartInterceptor):

    def start_data(self, md, *args, **kwargs):
        host, port = args[0], args[1]
        # print('host[%s] port[%s]' % (host, port,))
        setEnvironIp(host)
        setEnvironPort([port,])


def intercept_wsgiref(agent, mod):
    WsgirefMakeServerInterceptor(agent, mod).attach('make_server')
