from . import HookTestCase


class FlaskHookTest(HookTestCase):
    def test_wsgi_entry_point(self):
        from flask import Flask

        with self.assertRaises(AttributeError):
            Flask.wsgi_app._bonr_intercepted

        from Bonree.agent import bootstrap
        bootstrap()

        from flask import Flask
        self.assertTrue(Flask.wsgi_app._bonr_intercepted)

    def test_flask_entry_point(self):
        from flask import Flask

        with self.assertRaises(AttributeError):
            Flask.handle_user_exception._bonr_intercepted

        from Bonree.agent import bootstrap
        bootstrap()

        from flask import Flask
        self.assertTrue(Flask.handle_user_exception._bonr_intercepted)