'use strict';

function NextHook(agent)
{
  this.agent = agent;
  this.packages = ['next'];
  this.baseHook = agent.baseHook;
}

exports.NextHook = NextHook;

NextHook.prototype.attach = function(obj) {
  var self = this;

  if(obj.__bonrAttached__) return;
  obj.__bonrAttached__ = true;

};


NextHook.prototype.hookConstructor = function(obj) {
    var self = this;
    var baseHook = this.baseHook;
    var orig = obj;
    function NextWithHook() {
        var ret = orig.apply(this, arguments);
        baseHook.wrapAsyncMethod(ret.__proto__, 'next.prepare');
        baseHook.wrapAsyncMethod(ret.__proto__, 'next.render');
        baseHook.wrapAsyncMethod(ret.__proto__, 'next.handleRequest',function (obj, args, locals) {
            var txn = self.agent.tracer.getTransaction();
            if(!!txn && !txn.component) txn.component='Next';
        });
        return ret;
    }
    for (var attr in orig) {
        NextWithHook[attr] = orig[attr];
    }

    return NextWithHook;
};