var limited_async_trace=function(agent){

// Keep track of our current stack.
    this.agent=agent;
    this.currentStack = [];
    this.txnArr = [];
    this.txnId=-1;
    this.txnIdToSet=-1;

};

limited_async_trace.prototype.enableAsyncHooks=function(){
    var async_wrap = process.binding('async_wrap');
    // var kCallInitHook = 0;
    // var asyncHooksObject = {};
    var self=this;
    function asyncInit() {
        // Generate a new stack for this call site.
        var stack = {};
        Error.captureStackTrace(stack, asyncInit);
        //err.push(stack.stack);
        // Add a copy of the current stack plus new stack to propagate.
        var newStack = self.currentStack.slice(0);
        newStack.push(stack);
        if(self.txnArr.length>0){
            self.txnId=self.txnArr[self.txnArr.length-1];
        }
        this._asyncQueue = { stack: stack, stack_arr: newStack };


    }

    function asyncBefore() {
        // Add this stack to the current stack.
        if(self.txnIdToSet!==-1){
            self.txnArr.push(self.txnIdToSet);
            self.txnIdToSet=-1;
        }else{
            self.txnArr.push(self.txnId);
        }
        self.currentStack.push(this._asyncQueue.stack);
    }

    function asyncAfter() {
        // Remove this stack.
        self.txnArr.pop();

        self.currentStack.pop();
    }
    // async_wrap.setupHooks(asyncHooksObject, asyncInit, asyncBefore, asyncAfter);
    // asyncHooksObject[kCallInitHook] = 1;
    async_wrap.setupHooks(asyncInit,asyncBefore,asyncAfter);
    async_wrap.enable();
};


limited_async_trace.prototype.setTransactionId=function(txnId){
    var self=this;
    self.txnIdToSet=txnId;
};
limited_async_trace.prototype.getTransactionId=function(){

    var self=this;
    if(self.txnIdToSet==-1){
       
        return self.txnId;
    }else{

        return self.txnIdToSet;
    }

};



module.exports=limited_async_trace;

