'use strict';

var namedWrapFunc = function(index){
    return 'function (func) {'+
        '    return function bonr_wrap_'+index + '() {' +
        '    return func.apply(this,arguments);' +
        '};'+
        '}'
}

var namedWrapContent = '\'use strict\';\nmodule.exports = {\n';
for(var i = 0;i < 256;i++){
    namedWrapContent += i+':'+namedWrapFunc(i) + ',\n';
}
namedWrapContent+='};\n';

var fs = require('fs');
fs.writeFileSync('./lib/core/namedwrap.js',namedWrapContent);

