var bonree = require('bonree').profile({'configFile': './bonree.yml',enablelogging: true});
var express = require('express');
var mysql = require('mysql');
var sqlite3 = require('sqlite3');
var redis = require('redis');
var http = require('http');
var MongoClient = require('mongodb').MongoClient;
var DB_CONN_STR = 'mongodb://192.168.1.168:27017/test';
var fs = require('fs');

var client = redis.createClient(6379, "127.0.0.1");

function MysqlOpt() {
    this.pool = undefined;
}

MysqlOpt.prototype.init = function(ip, usr, passwd, database, port) {

    this.pool = mysql.createPool({
        host: ip,
        user: usr,
        password: passwd,
        database: database,
        port: port
    });

    client.on("error", function(err){
        console.log("Error: " + err);
    });

    client.on("connect", function(){
        console.log('redis connect!');
    });
};

MysqlOpt.prototype.insertData = function(db, callback) {

    var collection = db.collection('data');
    var data = [{"name":"addr1","url":"www.runoob.com"},{"name":"addr2","url":"c.runoob.com"}];
    collection.insert(data, function(err, result) {
        if(err)
        {
            console.log('Error:'+ err);
            return;
        }
        callback(result);
    });
};

MysqlOpt.prototype.httpReq = function(url) {
// 用于请求的选项
    var options = {
        host: 'localhost',
        port: '8888',
        path: url
    };

// 处理响应的回调函数
    var callback = function(response){
        // 不断更新数据
        var body = '';
        response.on('data', function(data) {
            body += data;
        });

        response.on('end', function() {
            // 数据接收完成
            console.log(body);
        });
    }
// 向服务端发送请求
    var req = http.request(options, callback);
    req.end();
}

MysqlOpt.prototype.query = function(sql,br, callback){

    var self = this;
    if (br === 1) {
        fs.writeFile('1.txt', 'data', function(err) {
            if(!!err) {
                console.log('write err');
            }
        });

        client.set("name_key", "hello world", function(err, reply){
            console.log(reply.toString());
        });

        client.get("name_key", function(err, reply){
            console.log(reply.toString());
        });
        self.httpReq('/test1?param=1');
        self.pool.getConnection(function(err,conn){
            if(err){
                console.log('getConnection failed!', err);
                callback(err,null,null);
            }else{
                conn.query(sql,function(qerr,vals,fields){
                    conn.release();
                    callback(qerr,vals,fields);
                });
            }
        });
    } else if(br == 2) {
        client.set("hello_key", "=hello world=", function(err, reply){
            console.log(reply.toString());
        });

        client.get("hello_key", function(err, reply){
            console.log(reply.toString());
        });
        self.httpReq('/test2?param=2');
        MongoClient.connect(DB_CONN_STR,function(err, db) {
            if(err) {
                console.log("连接失败！");
            } else {

                console.log("conenct success by string of mongodb");
                self.insertData(db, function(result) {
                    console.log(result);
                    var selectData = function(db, callback) {
                        var collection = db.collection('data');
                        var whereStr = {"name":'addr1'};
                        collection.find(whereStr).toArray(function(err, result) {
                            db.close();
                            callback(err,null, null);
                        });
                    };
                    selectData(db,callback);
                    //callback(err, null, null);
                });
            }
        });
    }
    return;

    var dbfile = '/tmp/1.db';
    if(fs.existsSync(dbfile)) {
        fs.unlinkSync(dbfile);
    }
        var db = new sqlite3.Database('/tmp/1.db',function() {
       /* MongoClient.connect(DB_CONN_STR,function(err, db) {
            if(err) {
                console.log("连接失败！");
            } else {

                console.log("conenct success by string of mongodb");
                self.insertData(db, function(result) {
                    console.log(result);
                    db.close();
                    //callback(err, null, null);
                });
            }

        });*/


            db.run("create table test(name varchar(15))",function(){
            db.run("insert into test values('hello,world')",function(){
                db.all("select * from test",function(err,res){
                    if(!err)
                        console.log(JSON.stringify(res));
                    else
                        console.log(err);
                    self.pool.getConnection(function(err,conn){
                        if(err){
                            console.log('getConnection failed!', err);
                            callback(err,null,null);
                        }else{
                            conn.query(sql,function(qerr,vals,fields){
                                conn.release();
                                callback(qerr,vals,fields);
                            });
                        }
                    });

                });
            });
        });
    });
};

var app = express();
var mysqlOpt = new MysqlOpt();
mysqlOpt.init('127.0.0.1', 'root', '123456', 'testdb', 3306);

app.get('/get_usr', function get_user(req, res) {
    console.log('get_usr');
    var params = req.query || req.params;
    var sqlStr = 'select * from testtb where usr=\'' + params.usr + '\'';
    console.log('sqlStr:', sqlStr);
    mysqlOpt.query(sqlStr, 1, function(err, vals, fileds) {
        if(err) {
            console.log(err);
            res.send('get usr failed!');
        } else {
            res.send('get usr ok!');
        }
    });
});

app.get('/get_usr_info', function get_user(req, res) {
    console.log('get_usr');
    var params = req.query || req.params;
    var sqlStr = 'select * from testtb where usr=\'' + params.usr + '\'';
    console.log('sqlStr:', sqlStr);
    mysqlOpt.query(sqlStr,2, function(err, vals, fileds) {
        if(err) {
            console.log(err);
            res.send('get usr failed!');
        } else {
            res.send('get usr ok!');
        }
    });
});

app.get('/add_usr', function (req, res) {
    console.log('add_usr');
    var params = req.query || req.params;
    var sqlStr = 'insert into testtb(usr,passwd) values(\'' + params.usr + '\',\'' + params.passwd +'\')';
    console.log(sqlStr);
    mysqlOpt.query(sqlStr, function(err, vals, fileds) {
        if(err) {
            console.log(err);
            res.send('add usr failed!');
        } else{
            res.send('add usr ok!');
        }
    });
});

var server = app.listen(8081, function () {

    var host = server.address().address
    var port = server.address().port

    console.log("应用实例，访问地址为 http://%s:%s", host, port)

});