import re
from Bonree import config
from Bonree.lang import urlparse
from Bonree.agent.proto import pb_config, pb_type



def parse_sql_cmd(b_type, oper):
    """
    Paramters:
    ------------
    oper: the operation string

    Return:
    ------------
    """
    return oper


def parse_nosql_cmd(b_type, oper):
    result = oper.lower()

    if b_type == pb_type.BACKEND_TYPE_MONGODB:
        result = re.findall('[a-zA-Z0-9]+', result[:20])
        if not result:
            return ''
        if result[0] == "son" and len(result)>1:
            result = result[1]
        else:
            result = result[0]
    elif b_type == pb_type.BACKEND_TYPE_MEMCACHE or b_type == pb_type.BACKEND_TYPE_SSDB:
        result = oper.lower().split('(', 1)[0]
    else:
        result = oper.lower().split(' ', 1)[0]

    return result


def parse_remote_cmd(b_type, oper):
    return oper
