from Bonree.agent.interceptor.base import ThreadEntryPointInterceptor


class ThreadInterceptor(ThreadEntryPointInterceptor):

    def start_data(self, md, target, *args, **kwargs):
        btr = self.btr
        if not btr:
            return

        target = self.target_wrapper(target, btr)
        md.args[0] = target


def intercept_thread(agent, mod):
    ThreadInterceptor(agent, mod).attach(['start_new', 'start_new_thread'])
