from Bonree.agent.interceptor.base import OnlyStartInterceptor
from Bonree.config import setEnvironIp, setEnvironPort


class DaphneListenInterceptor(OnlyStartInterceptor):

    def start_data(self, md, server, port, *args, **kwargs):
        if hasattr(port, "getHost"):
            host = port.getHost()
            if hasattr(host, "host") and hasattr(host, "port"):
                setEnvironIp(host.host)
                setEnvironPort([host.port, ])


def intercept_daphne(agent, mod):
    DaphneListenInterceptor(agent, mod.Server).attach('listen_success')
