from Bonree.agent.interceptor.base import OnlyStartInterceptor
from Bonree.config import setEnvironIp, setEnvironPort


class GunicornMakeServerInterceptor(OnlyStartInterceptor):

    def start_data(self, md, application, *args, **kwargs):
        address = application.cfg.address # [('0.0.0.5', 5000)]
        if not address:
            return
        bind = address[0]
        host, port = bind[0], bind[1]
        setEnvironIp(host)
        setEnvironPort([port, ])


def intercept_gunicorn(agent, mod):
    GunicornMakeServerInterceptor(agent, mod.Application).attach('run')
