from Bonree.agent.interceptor.base import CustomBtInterceptor


class OpenStackBackGroundInterceptor(CustomBtInterceptor):

    def custom_bt_entry(self, origin_method, *args, **kwargs):
        btr = self.btr
        if btr:
            if not btr.close_flag:
                now = self.agent.time()
                if now - btr.timer.start_time > 60 * 1000000: # 1min
                    self.end_transaction_request(btr)

        response = super(OpenStackBackGroundInterceptor, self).custom_bt_entry(origin_method, *args, **kwargs)
        return response
