# Copyright (c) Bonree, Inc., and its affiliates
# 2015
# All Rights Reserved

"""Interceptor for Flask framework.

"""

from Bonree.agent.interceptor.base import OnlyStartInterceptor
from Bonree.config import setEnvironIp, setEnvironPort


class WerkzeugBaseWSGIServerInitInterceptor(OnlyStartInterceptor):
    def start_data(self, md, origin_self, host, port, *args, **kwargs):
        # print('WerkzeugBaseWSGIServerInitInterceptor host[%s] port[%s]' % (host, port))
        setEnvironIp(host)
        setEnvironPort([port,])


def intercept_werkzeug_serving(agent, mod):
    WerkzeugBaseWSGIServerInitInterceptor(agent, mod.BaseWSGIServer).attach('__init__')