# Copyright (c) Bonree, Inc., and its affiliates
# 2018
# All Rights Reserved

from Bonree.lang import str

NEED_SAMPLE = 'a'
IS_ASYNC = 'b'
TRACE_ID = 'c'
RPC_ID = 'd'
FROM_AGENT_ID = 'e'
FROM_TRANSACTION_ID = 'f'
RPC_HOST = 'g'
BACKEND_TYPE = 'h'
BR_CS_REQ = 'br-cs-req'
BR_CS_RSP = 'br-cs-rsp'
TO_AGENT_ID = 'o'
SPLIT_KEYVALUE = '='
TRACE_SPE = ';;'
TRACE_SPLIT_TRANS = '||'
TRACE_SPLIT_TRANS_REGISTER = ',,'

SET_COOKIE = 'Set-Cookie'


class CrossHeader(dict):
    """deprecated"""
    _default_keys = [NEED_SAMPLE, IS_ASYNC, TRACE_ID, RPC_ID, FROM_AGENT_ID, FROM_TRANSACTION_ID, RPC_HOST,
                     BACKEND_TYPE, TO_AGENT_ID]

    def __setitem__(self, key, value):
        if key in CrossHeader._default_keys:
            dict.__setitem__(self, key, str(value))
