release notes

version 5.2.0
 1. A 适配openstack的控制节点面板dashboard
 2. A 适配openstack计算节点nova-compute进程
 3. A 适配openstack计算节点nova-conductor进程
 4. A 适配openstack计算节点nova-scheduler进程
 5. A 适配openstack的 cinder-scheduler进程
 6. A 适配openstack的 cinder-volume进程
 7. A 适配openstack的 neutron-server 进程
 8. U 优化调用链中异常详情的异常堆栈信息

version 5.1.0
 1. A 支持自定义业务入口(支持函数回调)与自定义trace函数
 2. U 对pip命令不进行探针注入
 3. U 对于setup.py install 命令不进行注入
 4. U 优先考虑用户设置的自定义状态码
 5. U 由从路径获取版本号改为从version.txt文件中获取版本号
 6. F 修复在未开启nosql采集指令时，redis集群未上报后端调用detail
 7. F 修复mysql执行异常时没有采集sql的问题
 8. F 修复trace中uri字段被业务命名规则截断的问题
 9. F 修复trace里requestData的url和tags的url缺少url参数问题
10. F 修复bytearray未转换为str类型问题

version 5.0.1
 1. F 修复在未开启nosql采集指令时，redis集群未上报后端调用detail(采集指令），导致web未展示统计数据

version 5.0.0
 1. A 探针支持starlette异步web框架 (0.12.0及以上)(python3.6+)
 2. A 探针支持quart异步web框架 (0.11.0及以上)(python3.7+)
 3. A 探针支持fastapi异步web框架 (0.23.0及以以上)(python3.6+)
 4. A 探针支持aiohttp调用rpc (3.0.0及以上)(python3.7+)
 5. A 探针支持uvicorn容器启动方式
 6. A 探针支持daphne容器启动方式
 7. A 探针支持django3异步启动方式
 8. A 日志支持追加traceid
 9. A hive数据库类型使用BACKEND_TYPE_HIVE
10. A 移除阈值模式,实现智能采集功能
11. A 探针日志python_agent.log本地配置文件开关进行控制
12. U 数据融合不需要设置set-cookie
13. U 优化探针首次生效的SDK轮询间隔时间
14. U 去掉本地 sql 执行计划开关，采用协议开关字段
15. U http状态码错误原因统一为HTTP ERROR (<code>)格式
16. F 修复rpc调用时间计算错误问题
17. F 修复crossbt中br-cs-rsp类型问题
18. F 修复rpc调用中peer.service标签
19. F 修复rpc调用时调用链里backendCall字段缺失
20. F 修复TraceTags信息缺失问题
21. F 修复数据库语句格式化问题
22. F 修复日志抓取格式化
23. F 修复mongo认证命令导致探针数组越界问题
24. F 修复进行http的rpc调用时，错误和异常统计数量错误
25. F 修复探针没有采集sanic异常问题
26. F 修复探针没有采集webpy异常问题
27. F 修复thrift跨容器的拓扑图连线问题
28. F 修复默认使用url中的path作为业务命名
29. F 修复运行的trace的结束时间默认设为业务的结束时间

version 4.1.2
1. A 新增 探针日志python_agent.log本地配置文件开关进行控制
2. F 修复 修复rpc调用时调用链里backendCall字段缺失问题

version 4.1.1
1. F 修复 mongo认证命令导致探针数组越界问题

version 4.1.0
 1. A 新增 日志输出格式增加进程号. 线程号和微妙粒度时间 （c-agent）
 2. A 新增 业务名称混淆数字部分（c-agent）
 3. A 新增 上报数据包含完整的业务实体（btid，btname等）（c-agent）
 4. A 新增 上报数据去掉方法注册，调用链上报原始方法数据（c-agent）
 5. A 新增 上报数据包含完整的后端实体（c-agent）
 6. A 新增 上报数据包含完整的后端详情实体（c-agent）
 7. A 新增 协议升级V6.3
 8. A 新增 适配Thrift框架（客户端和服务端)
 9. A 新增 从smartagentConfig协议获取最大内存并通过Config协议上报
10. A 新增 探针注入前判断平台是否满足要求
11. A 新增 进程启动后30秒，探针发送Config请求到SDK
12. A 新增 增加本地配置，默认关闭SQL执行计划
13. A 新增 采集模式支持阈值模式,阈值模式默认关闭
14. A 新增 增加对Python3.8/3.9的支持
15. A 新增 支持xmlrpc (Python3)的server端探针
16. A 新增 支持xmlrpclib (Python2)的server端探针
17. A 新增 支持grpc server端探针
18. A 新增 新增hive
29. A 新增 支持smartagent自定义安装目录
20. A 新增 调用链新增阈值模式
21. A 新增 新增gunicorn探针
22. A 新增 添加elasticsearch探针支持
23. A 新增 python探针log目录支持动态smartagent安装目录
24. U 更新 非数据库这db*的字段可以不传
25. F 修复 rabbitmq插码兼容librabbitmq协议和amqp协议   
26. F 修复 修复探针在python2.6上不可用的问题
27. F 修复celery中属性获取错误 
28. F 修复 sitecustomize相关异常
29. F 修复 过滤python相关自带库的hook
30. F 修复 跨容器请求数据转成str类型
31. F 修复 探针使用自身的配置文件，不从smartagent中读取
32. F 修复 修复MySQLdb在旧版本(1.3.0)中获取不到标签问题

version 4.0.0
1. U 更新 更新协议至v6.2.0，升级探针版本到4.0.0
2. U 更新 适配smartagent
3. F 修复 重构数据构建和传输方式，使用sdk接口
4. F 修复 重构部分trace模块和cross模块代码
5. F 修复 异常数据不完整
6. F 修复 rabbitmq获取不到后端数据
7. F 修复 参数名重复的导致hook失败的问题

version 3.5.0
1. U 更新 redis和activemq的hook方法
2. U 更新 探针和proxy一键安装可以实现更新功能
3. F 修复 trace头编码问题
4. F 修复 apache、uwsgi带探针启动网站的异常问题
5. F 修复 IP和端口获取异常的问题
6. F 修复 重构部分trace代码
7. F 修复 tonado框架获取数据不全的问题
8. F 修复 热点方法配置失效问题

version 3.4.1
1. F 修复 开启获取trace后，cpu资源占用异常

version 3.4.0
1. U 更新 更新协议至v5.3，升级探针版本到3.4.0
2. U 更新 配置文件解析的调整，加入python内置confparse类
3. U 更新 探针与proxy分离，并实现探针与proxy的脚本一键安装
4. U 更新 js注入的位置，可配置
4. A 新增 调用链的tags数据
5. A 新增 添加kafka的支持
6. A 新增 探针支持windows平台
7. F 修复 重构独立后端代码
8. F 修复 重构base框架
9. F 修复 trace数据获取部分代码重构

version 3.3.1
1. F 修复 修复访问数据库发生死锁的问题
2. F 修复 修复禅道bug 4733 远程调用url不正确的问题
3. F 修复 修复禅道bug 4734 parentBT中没有internalName字段的错误
4. F 修复 修复禅道bug 3393 设置调用栈热点配置方法默认显示
5. F 修复 修复禅道bug 2541 添加bt name默认命名规则配置
6. U 更新 打包优化,优化探针依赖需要编译的库psutil

version 3.3.0
1. U 更新 更新协议至v5.2，升级探针版本到3.3.0
2. A 新增 支持独立后端上报
3. F 修复 修复禅道bug 2540 调用栈中rpcid填充不正确的问题
4. F 修复 修复禅道bug 2542 uri填充不正确的问题

version 3.2.0
1. A 新增 支持nosql后端ssdb 1.9.6
2. A 新增 支持后台任务类型invoke 1.2.0
3. U 更新 更新v5.1协议
4. F 修复 重构trace获取部分代码
5. F 修复 重构数据上传部分代码

version 3.1.0
1. A 新增 新增activemq、edb的支持
2. A 新增 添加对stompy库的支持
3. F 修复 修复热点字符串编码不是utf-8的问题

version 3.0.0
1. U 更新 agent注册业务、后端实体，相关上报数据都要使用id值
2. U 更新 热点方法获取行号
3. U 更新 tracedata封装上报
4. U 更新 tracedata支持trace采集概率
5. U 更新 tracedata支持http参数采集
6. U 更新 tracedata支持请求头字段采集
7. U 更新 controller下发registerFlag需要清空业务、后端注册缓存
8. U 更新 CrossBTMetric在服务端生成
9. A 新增 调用链支持
10. U 更新 修改数据融合
      a.返回header修改
      b.去掉数据融合数据上报

version 2.5.0
1. U 更新 升级协议到4.0版本，业务属性添加uri
2. U 更新 更新协议并添加快照新增parentBT字段
3. A 新增 添加对sanic框架的支持
4. A 新增 添加对apistar框架支持
5. F 修复 修复web.py框架跨容器错误问题

version 2.4.6
1. F 修复 修改探针对django的exception hook方式;
2. A 新增 支持django2.0

version 2.4.5
1. A 新增 proxy集成machineagent的功能；
2. A 新增 添加对web.py框架的支持；

version 2.4.4
1. U 更新 升级协议到3.6
2. A 新增 添加对logging、eliot、logbook日志库的支持
3. A 新增 添加对调用日志链的支持
4. F 修复 修复python3环境中运行错误，支持python3环境
5. F 修复 修改跨容器调用

version 2.4.3
1. A 新增 添加对django框架的template的render方法的hook，修复js注入失败的问题
2. F 修复 修复配置文件中日志目录没有写入权限导致探针启动失败的问题
3. F 修复 修复将bytes转换成str时出错的问题

version 2.4.2
1. F 修复 探针hook psycopg2库时出现的异常问题
2. F 修复 探针hook ubuntu14.04自带的requests库出现的属性错误问题

version 2.4.1
1. A 新增 添加对odoo 6.1,7,8,9,10,11支持
2. A 新增 添加快照展示sql执行计划
3. A 新增 添加自定义健康阀值
4. A 新增 添加自定义错误码
5. A 新增 添加支持日志下载
6. F 修复 修复sql显示带占位符

version 2.3.3
1. A 新增 添加业务黑名单；
2. A 新增 添加快照采集概率；
3. A 新增 添加快照过滤；
4. F 修复 rabbitmq入口hook中的异常；

version 2.3.2
1. A 新增 添加了对采集数据数量的限制，主要内容如下：
    a.同时刻处于采样状态的业务数量不超过20个，如果已经有20个业务正在采集快照，新业务的快照采集请求将被忽略；
    b.业务中单个线程上记录的后端数量不超过100个，超过部分的后端调用信息将被忽略；
    c.业务总后端数量不超过500个，超过部分的后端调用信息将被忽略；
    d.业务快照中的节点总数不超过5000个，超过部分节点信息将被丢弃。
2. U 更新 升级协议到3.2；
3. U 更新 修改业务命名规则；
4. A 新增 添加flask、django、tornado框架下的js注入功能；
5. F 修复 修正设置黑名单后再清空黑名单，探针扔保留最后一次非空的黑名单设置；

version 2.3.1
1. A 新增 增加rabbitmq远程调用支持
2. F 修复 修正uwsgi启动的bug
3. F 修复 修正tornado coroutine快照异常的bug，暂停对greenlet的支持；
4. F 修复 修正cx_Oracle引起的卡死bug

version 2.3
1. A 新增 添加了对cx_Oracle的支持；
2. F 修复 修正部分bug；

version 2.2
1. A 新增 添加了对tornado3框架的支持；
2. A 新增 添加异常黑名单；
3. A 新增 添加对bottle框架的支持；
4. A 新增 添加对cherrypy框架的支持；
5. U 更新 抓取快照函数参数信息；
6. A 新增 添加对elasticsearch库支持；
7. A 新增 添加对xmlrpclib库支持；
8. A 新增 添加对celery后台任务支持；

version 2.1
1. A 新增 添加了对redis调用的支持；
2. A 新增 支持apache 2下探针的启动支持；
3. A 新增 支持uwsgi下探针的启动支持；
4. A 新增 支持http调用的cross metric；
5. A 新增 支持跨容器快照下钻

version 2.0
1. U 更新 进入proxy模块，优化agent性能
2. U 更新 Metric主要业务迁移到Proxy完成，减轻agent负担
3. U 更新 快照控制更精细，同一个app的不同进程不再重复发送快照数据
4. A 新增 基于Zeromq的最新本地通信协议
5. U 更新 proxy自带jre，不再要求依赖客户环境中的jre8

version 1.1
1. A 新增 支持Pyramid
2. A 新增 支持psycopg2 2.6.2及以上
3. F 修复 修正空快照没有过滤的问题
4. U 更新 优化线程/greenlet的hook
5. U 更新 优化快照过滤算法
6. U 更新 改进启动方式，优化用户体验

version 1.0
1. A 新增 支持CPython 2.6/2.7/3.4/3.5
2. A 新增 支持Flask 0.1及以上
3. A 新增 支持Django 1.6及以上
4. A 新增 支持Tornado 4.2及以上
5. A 新增 支持Mysql-Python 1.2.5及以上
6. A 新增 支持MysqlClient 1.3.9及以上
7. A 新增 支持Flask-MysqlDB 0.2.0及以上
8. A 新增 支持mysql-connector-python-rf 2.1.3及以上
9. A 新增 支持Pymongo 3.3.1及以上
10. A 新增 支持python-memcached 1.5.8及以上
11. A 新增 支持urllib3 1.18及以上
12. A 新增 支持requests 2.12及以上