# Python Agent

## 1. 探针支持环境列表

### 1.1 操作系统

- Centos/Redhat Linux-7-x86_64
- Centos/Redhat Linux-6-x86_64
- Ubuntu-16.04
- Ubuntu-14.04
- Windows7

###  1.2 容器
-  Apache 2
-  Uwsgi
-  Gunicorn
-  uvicorn
-  daphne (2.x及以上)

### 1.3 Python 版本
- 2.6
- 2.7
- 3.4
- 3.5
- 3.6
- 3.7
- 3.8
- 3.9

### 1.4 数据库
Mysql:
- Pymysql                    0.7.1及以上/0.10.1
- mysqlclient                1.3.0及以上/2.0.1
- mysql-connector-python     8.0.5及以上/8.0.22

PostgreSQL：
- psycopg2                   2.6.2及以上/2.8.6

Oracle:
- Cx-Oracle                  6.0及以上/8.0.1

Hive:
- pyhive                     0.1.6及以上/0.6.3


### 1.5 NOSQL
Mongodb:
- Pymongo                    3.3.0及以上/3.11.1

Memcache:
- python-memcached           1.57及以上/1.5.9

Ssdb:
- pyssdb                     0.4.0及以上/0.4.2

Redis:
- redis                      2.10.0及以上/3.5.3
- redis-py-cluster           0.1.0及以上/2.1.0

### 1.6 RPC
- urllib3                    1.18及以上/1.26.2
- requests                   2.12.0及以上/2.25.0 
- httplib                    python 2.6/2.7/3.4/3.5/3.6/3.7/3.8/3.9
- tornado_httpclient         3.1及以上6.1
- elasticsearch              5.2.0及以上/7.10.0
- grpcio                     1.0.0及以上/1.33.2
- xmlrpclib                  python 2.6/2.7
- xmlrpc                     python 3.4/3.5/3.6/3.7/3.8/3.9
- thrift                     0.10.0及以上/0.13.0
- aiohttp(python3.7+)        3.0.0及以上/3.7.3

### 1.7 MQ：
Kafka:
- kafka-python               1.3.0及以上/2.0.2
Activemq:
- stomp.py                   4.1.20及以上/6.1.0
RabbitMQ:
- kombu                      3.0.30及以上/5.0.2
- librabbitmq                1.6.0及以上2.0.0

### 1.8 Frameworks
- Flask:                     0.10及以上/1.1.2 
- Django:                    1.5/1.6/1.7/1.8/ 1.9/1.10/1.11/2.0/2.1/2.2/3.0/3.1
- Tornado:                   3.0及以上/6.1
- Web.py:                    0.33/0.34/0.35/0.36/0.37/0.38/0.39/0.40/0.5.1/0.6.1/0.6.2
- Pyramid:                   1.3及以上/1.10.5
- Bottle:                    0.12及以上/0.12.19
- Cherrypy:                  10.0及以上/18.6.0
- Sanic:                     0.5.0及以上/20.9.1
- Odoo:                      8、9、10、11、12、13、14
- fastapi (python3.6+)       0.23.0及以0.63.0
- quart：(python3.7+)        0.11.0及以0.14.1  
- starlette (python3.6+)     0.12.0及以上0.14.1

### 1.9 Log
- Logging：                  Python 2.6/2.7/3.4/3.5/3.6
- logbook                    1.3.0及以上/1.5.3
- Eliot:                     0.8.0及以上/1.12.0

### 2.0 后台任务
- celery                     3.1.0及以上/5.0.2
- invoke                     0.12.0及以上/1.4.1

## 2. 适配SmartAgent版本
- 协议版本: 7.1.0
